Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90	(revision 9123)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/DYN/wet_dry.F90	(revision 9124)
@@ -26,5 +26,5 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! MPP library
-   USE timing         ! Timing
+   USE timing         ! timing of the main modules
 
    IMPLICIT NONE
@@ -71,9 +71,8 @@
       !! ** input   : - namwad namelist
       !!----------------------------------------------------------------------
-      !!
-      NAMELIST/namwad/ ln_wd_il, ln_wd_dl, rn_wdmin0, rn_wdmin1, rn_wdmin2, rn_wdld, &
-                     & nn_wdit, ln_wd_dl_bc, ln_wd_dl_rmp
-      INTEGER  ::   ios                 ! Local integer output status for namelist read
-      INTEGER  ::   ierr                ! Local integer status array allocation 
+      INTEGER  ::   ios, ierr   ! Local integer
+      !!
+      NAMELIST/namwad/ ln_wd_il, ln_wd_dl   , rn_wdmin0, rn_wdmin1, rn_wdmin2, rn_wdld,   &
+         &             nn_wdit , ln_wd_dl_bc, ln_wd_dl_rmp
       !!----------------------------------------------------------------------
       !
@@ -100,14 +99,13 @@
          WRITE(numout,*) '      T => baroclinic u,v=0 at dry pts: ln_wd_dl_bc = ', ln_wd_dl_bc     
          WRITE(numout,*) '      use a ramp for rwd limiter:  ln_wd_dl_rwd_rmp = ', ln_wd_dl_rmp
- 
       ENDIF
       IF( .NOT. ln_read_cfg ) THEN
          IF(lwp) WRITE(numout,*) '      No configuration file so seting ssh_ref to zero  '
-         ssh_ref=0.0
+         ssh_ref=0._wp
       ENDIF
 
-      r_rn_wdmin1=1/rn_wdmin1
+      r_rn_wdmin1 = 1 / rn_wdmin1
       ll_wd = .FALSE.
-      IF(ln_wd_il .OR. ln_wd_dl) THEN
+      IF( ln_wd_il .OR. ln_wd_dl ) THEN
          ll_wd = .TRUE.
          ALLOCATE( wdmask(jpi,jpj),   STAT=ierr )
@@ -144,8 +142,6 @@
       REAL(wp),  DIMENSION(jpi,jpj) ::   zflxu1 , zflxv1    ! local 2D workspace
       !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('wad_lmt')
-      !
-       
+      IF( ln_timing )   CALL timing_start('wad_lmt')      !
+      !
       DO jk = 1, jpkm1
          un(:,:,jk) = un(:,:,jk) * zwdlmtu(:,:) 
@@ -153,41 +149,35 @@
       END DO
       jflag  = 0
-      zdepwd = 50._wp   !maximum depth on which that W/D could possibly happen
-
+      zdepwd = 50._wp      ! maximum depth on which that W/D could possibly happen
+      !
       zflxp(:,:)   = 0._wp
       zflxn(:,:)   = 0._wp
       zflxu(:,:)   = 0._wp
       zflxv(:,:)   = 0._wp
-
-      zwdlmtu(:,:)  = 1._wp
-      zwdlmtv(:,:)  = 1._wp
-       
-      ! Horizontal Flux in u and v direction
-      DO jk = 1, jpkm1  
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zflxu(ji,jj) = zflxu(ji,jj) + e3u_n(ji,jj,jk) * un(ji,jj,jk) * umask(ji,jj,jk)
-               zflxv(ji,jj) = zflxv(ji,jj) + e3v_n(ji,jj,jk) * vn(ji,jj,jk) * vmask(ji,jj,jk)
-            END DO  
-         END DO  
-      END DO
-       
+      !
+      zwdlmtu(:,:) = 1._wp
+      zwdlmtv(:,:) = 1._wp
+      !
+      DO jk = 1, jpkm1     ! Horizontal Flux in u and v direction
+         zflxu(:,:) = zflxu(:,:) + e3u_n(:,:,jk) * un(:,:,jk) * umask(:,:,jk)
+         zflxv(:,:) = zflxv(:,:) + e3v_n(:,:,jk) * vn(:,:,jk) * vmask(:,:,jk)
+      END DO
       zflxu(:,:) = zflxu(:,:) * e2u(:,:)
       zflxv(:,:) = zflxv(:,:) * e1v(:,:)
-       
-      wdmask(:,:) = 1
+      !
+      wdmask(:,:) = 1._wp
       DO jj = 2, jpj
          DO ji = 2, jpi 
-
-            IF( tmask(ji, jj, 1) < 0.5_wp ) CYCLE              ! we don't care about land cells
-            IF( ht_0(ji,jj) - ssh_ref > zdepwd ) CYCLE   ! and cells which are unlikely to dry
-
-            zflxp(ji,jj) = max(zflxu(ji,jj), 0._wp) - min(zflxu(ji-1,jj),   0._wp) + &
-                         & max(zflxv(ji,jj), 0._wp) - min(zflxv(ji,  jj-1), 0._wp) 
-            zflxn(ji,jj) = min(zflxu(ji,jj), 0._wp) - max(zflxu(ji-1,jj),   0._wp) + &
-                         & min(zflxv(ji,jj), 0._wp) - max(zflxv(ji,  jj-1), 0._wp) 
-
+            !
+            IF( tmask(ji,jj,1)        < 0.5_wp )   CYCLE    ! we don't care about land cells
+            IF( ht_0(ji,jj) - ssh_ref > zdepwd )   CYCLE    ! and cells which are unlikely to dry
+            !
+            zflxp(ji,jj) = MAX( zflxu(ji,jj) , 0._wp ) - MIN( zflxu(ji-1,jj  ) , 0._wp )   &
+               &         + MAX( zflxv(ji,jj) , 0._wp ) - MIN( zflxv(ji,  jj-1) , 0._wp ) 
+            zflxn(ji,jj) = MIN( zflxu(ji,jj) , 0._wp ) - MAX( zflxu(ji-1,jj  ) , 0._wp )   &
+               &         + MIN( zflxv(ji,jj) , 0._wp ) - MAX( zflxv(ji,  jj-1) , 0._wp ) 
+            !
             zdep2 = ht_0(ji,jj) + sshb1(ji,jj) - rn_wdmin1
-            IF(zdep2 .le. 0._wp) THEN  !add more safty, but not necessary
+            IF( zdep2 <= 0._wp ) THEN     ! add more safty, but not necessary
                sshb1(ji,jj) = rn_wdmin1 - ht_0(ji,jj)
                IF(zflxu(ji,  jj) > 0._wp) zwdlmtu(ji  ,jj) = 0._wp
@@ -197,47 +187,42 @@
                wdmask(ji,jj) = 0._wp
             END IF
-         ENDDO
-      END DO
-
-
-! HPG limiter from jholt
+         END DO
+      END DO
+      !
+      !           ! HPG limiter from jholt
       wdramp(:,:) = min((ht_0(:,:) + sshb1(:,:) - rn_wdmin1)/(rn_wdmin0 - rn_wdmin1),1.0_wp)
-!jth assume don't need a lbc_lnk here
+      !jth assume don't need a lbc_lnk here
       DO jj = 1, jpjm1
          DO ji = 1, jpim1
-            wdrampu(ji,jj) = min(wdramp(ji,jj),wdramp(ji+1,jj))
-            wdrampv(ji,jj) = min(wdramp(ji,jj),wdramp(ji,jj+1))
+            wdrampu(ji,jj) = MIN( wdramp(ji,jj) , wdramp(ji+1,jj) )
+            wdrampv(ji,jj) = MIN( wdramp(ji,jj) , wdramp(ji,jj+1) )
          END DO
       END DO
-! end HPG limiter
-
-
-      
-        !! start limiter iterations 
-      DO jk1 = 1, nn_wdit + 1
-       
-          
+      !           ! end HPG limiter
+      !
+      !
+      DO jk1 = 1, nn_wdit + 1      !==  start limiter iterations  ==!
+         !
          zflxu1(:,:) = zflxu(:,:) * zwdlmtu(:,:)
          zflxv1(:,:) = zflxv(:,:) * zwdlmtv(:,:)
          jflag = 0     ! flag indicating if any further iterations are needed
-          
+         !
          DO jj = 2, jpj
             DO ji = 2, jpi 
-        
-               IF( tmask(ji, jj, 1) < 0.5_wp ) CYCLE 
-               IF( ht_0(ji,jj) > zdepwd )      CYCLE
-        
+               IF( tmask(ji, jj, 1) < 0.5_wp )   CYCLE 
+               IF( ht_0(ji,jj)      > zdepwd )   CYCLE
+               !
                ztmp = e1e2t(ji,jj)
-
-               zzflxp = max(zflxu1(ji,jj), 0._wp) - min(zflxu1(ji-1,jj),   0._wp) + &
-                      & max(zflxv1(ji,jj), 0._wp) - min(zflxv1(ji,  jj-1), 0._wp) 
-               zzflxn = min(zflxu1(ji,jj), 0._wp) - max(zflxu1(ji-1,jj),   0._wp) + &
-                      & min(zflxv1(ji,jj), 0._wp) - max(zflxv1(ji,  jj-1), 0._wp) 
-          
+               !
+               zzflxp = MAX( zflxu1(ji,jj) , 0._wp ) - MIN( zflxu1(ji-1,jj  ) , 0._wp)   &
+                  &   + MAX( zflxv1(ji,jj) , 0._wp ) - MIN( zflxv1(ji,  jj-1) , 0._wp) 
+               zzflxn = MIN( zflxu1(ji,jj) , 0._wp ) - MAX( zflxu1(ji-1,jj  ) , 0._wp)   &
+                  &   + MIN( zflxv1(ji,jj) , 0._wp ) - MAX( zflxv1(ji,  jj-1) , 0._wp) 
+               !
                zdep1 = (zzflxp + zzflxn) * z2dt / ztmp
                zdep2 = ht_0(ji,jj) + sshb1(ji,jj) - rn_wdmin1 - z2dt * sshemp(ji,jj)
-          
+               !
                IF( zdep1 > zdep2 ) THEN
-                  wdmask(ji, jj) = 0
+                  wdmask(ji, jj) = 0._wp
                   zcoef = ( ( zdep2 - rn_wdmin2 ) * ztmp - zzflxn * z2dt ) / ( zflxp(ji,jj) * z2dt )
                   !zcoef = ( ( zdep2 - rn_wdmin2 ) * ztmp - zzflxn * z2dt ) / ( zzflxp * z2dt )
@@ -245,48 +230,40 @@
                   ! changes have zeroed the coefficient since further iterations will
                   ! not change anything
-                  IF( zcoef > 0._wp ) THEN
-                     jflag = 1 
-                  ELSE
-                     zcoef = 0._wp
+                  IF( zcoef > 0._wp ) THEN   ;   jflag = 1 
+                  ELSE                       ;   zcoef = 0._wp
                   ENDIF
-                  IF(jk1 > nn_wdit) zcoef = 0._wp
-                  IF(zflxu1(ji,  jj) > 0._wp) zwdlmtu(ji  ,jj) = zcoef
-                  IF(zflxu1(ji-1,jj) < 0._wp) zwdlmtu(ji-1,jj) = zcoef
-                  IF(zflxv1(ji,  jj) > 0._wp) zwdlmtv(ji  ,jj) = zcoef
-                  IF(zflxv1(ji,jj-1) < 0._wp) zwdlmtv(ji,jj-1) = zcoef
-               END IF
-            END DO ! ji loop
-         END DO  ! jj loop
-
+                  IF( jk1 > nn_wdit )   zcoef = 0._wp
+                  IF( zflxu1(ji  ,jj  ) > 0._wp )   zwdlmtu(ji  ,jj  ) = zcoef
+                  IF( zflxu1(ji-1,jj  ) < 0._wp )   zwdlmtu(ji-1,jj  ) = zcoef
+                  IF( zflxv1(ji  ,jj  ) > 0._wp )   zwdlmtv(ji  ,jj  ) = zcoef
+                  IF( zflxv1(ji  ,jj-1) < 0._wp )   zwdlmtv(ji  ,jj-1) = zcoef
+               ENDIF
+            END DO
+         END DO
          CALL lbc_lnk_multi( zwdlmtu, 'U', 1., zwdlmtv, 'V', 1. )
-
-         IF(lk_mpp) CALL mpp_max(jflag)   !max over the global domain
-
-         IF(jflag == 0) EXIT
-          
+         !
+         IF( lk_mpp )   CALL mpp_max(jflag)   !max over the global domain
+         !
+         IF( jflag == 0 )   EXIT
+         !
       END DO  ! jk1 loop
-       
+      !
       DO jk = 1, jpkm1
-         un(:,:,jk) = un(:,:,jk) * zwdlmtu(:, :) 
-         vn(:,:,jk) = vn(:,:,jk) * zwdlmtv(:, :) 
-      END DO
-
-      CALL lbc_lnk_multi( un, 'U', -1., vn, 'V', -1. )
-        !
+         un(:,:,jk) = un(:,:,jk) * zwdlmtu(:,:) 
+         vn(:,:,jk) = vn(:,:,jk) * zwdlmtv(:,:) 
+      END DO
       un_b(:,:) = un_b(:,:) * zwdlmtu(:, :)
       vn_b(:,:) = vn_b(:,:) * zwdlmtv(:, :)
+      !
+!!gm TO BE SUPPRESSED ?  these lbc_lnk are useless since zwdlmtu and zwdlmtv are defined everywhere !
+      CALL lbc_lnk_multi( un  , 'U', -1., vn  , 'V', -1. )
       CALL lbc_lnk_multi( un_b, 'U', -1., vn_b, 'V', -1. )
-       
-      IF(jflag == 1 .AND. lwp) WRITE(numout,*) 'Need more iterations in wad_lmt!!!'
-       
+!!gm
+      !
+      IF(jflag == 1 .AND. lwp)   WRITE(numout,*) 'Need more iterations in wad_lmt!!!'
+      !
       !IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
-      !IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (update hdivn field)
-      !
-      !
-      !
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('wad_lmt')
-      !
-      IF( ln_timing )   CALL timing_stop('wad_lmt')
+      !
+      IF( ln_timing )   CALL timing_stop('wad_lmt')      !
       !
    END SUBROUTINE wad_lmt
@@ -303,9 +280,9 @@
       !! ** Action  : - calculate flux limiter and W/D flag
       !!----------------------------------------------------------------------
-      REAL(wp), INTENT(in)    ::   rdtbt    ! ocean time-step index
+      REAL(wp)                , INTENT(in   ) ::   rdtbt    ! ocean time-step index
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   zflxu,  zflxv, sshn_e, zssh_frc  
       !
       INTEGER  ::   ji, jj, jk, jk1     ! dummy loop indices
-      INTEGER  ::   jflag               ! local scalar
+      INTEGER  ::   jflag               ! local integer
       REAL(wp) ::   z2dt
       REAL(wp) ::   zcoef, zdep1, zdep2 ! local scalars
@@ -317,63 +294,56 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   zflxu1, zflxv1           ! local 2D workspace
       !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('wad_lmt_bt')
+      IF( ln_timing )   CALL timing_start('wad_lmt_bt')      !
       !
       jflag  = 0
-      zdepwd = 50._wp   !maximum depth that ocean cells can have W/D processes
-
+      zdepwd = 50._wp   ! maximum depth that ocean cells can have W/D processes
+      !
       z2dt = rdtbt   
-       
+      !
       zflxp(:,:)   = 0._wp
       zflxn(:,:)   = 0._wp
-
       zwdlmtu(:,:) = 1._wp
       zwdlmtv(:,:) = 1._wp
-       
-      ! Horizontal Flux in u and v direction
-       
-      DO jj = 2, jpj
+      !
+      DO jj = 2, jpj      ! Horizontal Flux in u and v direction
          DO ji = 2, jpi 
-
-           IF( tmask(ji, jj, 1 ) < 0.5_wp) CYCLE   ! we don't care about land cells
-           IF( ht_0(ji,jj) > zdepwd )      CYCLE   ! and cells which are unlikely to dry
-
-            zflxp(ji,jj) = max(zflxu(ji,jj), 0._wp) - min(zflxu(ji-1,jj),   0._wp) + &
-                         & max(zflxv(ji,jj), 0._wp) - min(zflxv(ji,  jj-1), 0._wp) 
-            zflxn(ji,jj) = min(zflxu(ji,jj), 0._wp) - max(zflxu(ji-1,jj),   0._wp) + &
-                         & min(zflxv(ji,jj), 0._wp) - max(zflxv(ji,  jj-1), 0._wp) 
-
+            !
+            IF( tmask(ji, jj, 1 ) < 0.5_wp) CYCLE   ! we don't care about land cells
+            IF( ht_0(ji,jj) > zdepwd )      CYCLE   ! and cells which are unlikely to dry
+            !
+            zflxp(ji,jj) = MAX( zflxu(ji,jj) , 0._wp ) - MIN( zflxu(ji-1,jj  ) , 0._wp )   &
+               &         + MAX( zflxv(ji,jj) , 0._wp ) - MIN( zflxv(ji,  jj-1) , 0._wp ) 
+            zflxn(ji,jj) = MIN( zflxu(ji,jj) , 0._wp ) - MAX( zflxu(ji-1,jj  ) , 0._wp )   &
+               &         + MIN( zflxv(ji,jj) , 0._wp ) - MAX( zflxv(ji,  jj-1) , 0._wp ) 
+            !
             zdep2 = ht_0(ji,jj) + sshn_e(ji,jj) - rn_wdmin1
-            IF(zdep2 .le. 0._wp) THEN  !add more safety, but not necessary
+            IF( zdep2 <= 0._wp ) THEN  !add more safety, but not necessary
               sshn_e(ji,jj) = rn_wdmin1 - ht_0(ji,jj)
-              IF(zflxu(ji,  jj) > 0._wp) zwdlmtu(ji  ,jj) = 0._wp
-              IF(zflxu(ji-1,jj) < 0._wp) zwdlmtu(ji-1,jj) = 0._wp
-              IF(zflxv(ji,  jj) > 0._wp) zwdlmtv(ji  ,jj) = 0._wp
-              IF(zflxv(ji,jj-1) < 0._wp) zwdlmtv(ji,jj-1) = 0._wp 
-            END IF
-         ENDDO
-      END DO
-
-      
-      !! start limiter iterations 
-      DO jk1 = 1, nn_wdit + 1
-       
-          
+              IF( zflxu(ji  ,jj  ) > 0._wp)   zwdlmtu(ji  ,jj  ) = 0._wp
+              IF( zflxu(ji-1,jj  ) < 0._wp)   zwdlmtu(ji-1,jj  ) = 0._wp
+              IF( zflxv(ji  ,jj  ) > 0._wp)   zwdlmtv(ji  ,jj  ) = 0._wp
+              IF( zflxv(ji  ,jj-1) < 0._wp)   zwdlmtv(ji  ,jj-1) = 0._wp 
+            ENDIF
+         END DO
+      END DO
+      !
+      DO jk1 = 1, nn_wdit + 1      !! start limiter iterations 
+         !
          zflxu1(:,:) = zflxu(:,:) * zwdlmtu(:,:)
          zflxv1(:,:) = zflxv(:,:) * zwdlmtv(:,:)
          jflag = 0     ! flag indicating if any further iterations are needed
-          
+         !
          DO jj = 2, jpj
             DO ji = 2, jpi 
-        
-               IF( tmask(ji, jj, 1 ) < 0.5_wp) CYCLE 
-               IF( ht_0(ji,jj) > zdepwd )      CYCLE
-        
+               !
+               IF( tmask(ji, jj, 1 ) < 0.5_wp )   CYCLE 
+               IF( ht_0(ji,jj)       > zdepwd )   CYCLE
+               !
                ztmp = e1e2t(ji,jj)
-
-               zzflxp = max(zflxu1(ji,jj), 0._wp) - min(zflxu1(ji-1,jj),   0._wp) + &
-                      & max(zflxv1(ji,jj), 0._wp) - min(zflxv1(ji,  jj-1), 0._wp) 
-               zzflxn = min(zflxu1(ji,jj), 0._wp) - max(zflxu1(ji-1,jj),   0._wp) + &
-                      & min(zflxv1(ji,jj), 0._wp) - max(zflxv1(ji,  jj-1), 0._wp) 
+               !
+               zzflxp = max(zflxu1(ji,jj), 0._wp) - min(zflxu1(ji-1,jj),   0._wp)   &
+                  &   + max(zflxv1(ji,jj), 0._wp) - min(zflxv1(ji,  jj-1), 0._wp) 
+               zzflxn = min(zflxu1(ji,jj), 0._wp) - max(zflxu1(ji-1,jj),   0._wp)   &
+                  &   + min(zflxv1(ji,jj), 0._wp) - max(zflxv1(ji,  jj-1), 0._wp) 
           
                zdep1 = (zzflxp + zzflxn) * z2dt / ztmp
@@ -399,25 +369,26 @@
             END DO ! ji loop
          END DO  ! jj loop
-
+         !
          CALL lbc_lnk_multi( zwdlmtu, 'U', 1., zwdlmtv, 'V', 1. )
-
+         !
          IF(lk_mpp) CALL mpp_max(jflag)   !max over the global domain
-
-         IF(jflag == 0) EXIT
-          
+         !
+         IF(jflag == 0)   EXIT
+         !
       END DO  ! jk1 loop
-       
+      !
       zflxu(:,:) = zflxu(:,:) * zwdlmtu(:, :) 
       zflxv(:,:) = zflxv(:,:) * zwdlmtv(:, :) 
-
+      !
+!!gm THIS lbc_lnk is useless since it is already done at the end of the jk1-loop
       CALL lbc_lnk_multi( zflxu, 'U', -1., zflxv, 'V', -1. )
-       
-      IF(jflag == 1 .AND. lwp) WRITE(numout,*) 'Need more iterations in wad_lmt_bt!!!'
-       
+!!gm end
+      !
+      IF( jflag == 1 .AND. lwp )   WRITE(numout,*) 'Need more iterations in wad_lmt_bt!!!'
+      !
       !IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
-      !IF( nn_cla == 1 )   CALL cla_div    ( kt )             ! Cross Land Advection (update hdivn field)
-      !
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('wad_lmt')
+      !
+      IF( ln_timing )   CALL timing_stop('wad_lmt_bt')      !
+      !
    END SUBROUTINE wad_lmt_bt
 
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 9123)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/FLO/flo_oce.F90	(revision 9124)
@@ -7,5 +7,5 @@
    !!   NEMO      1.0  ! 2002-11  (G. Madec, A. Bozec)  F90: Free form and module
    !!----------------------------------------------------------------------
-#if   defined key_floats
+#if   defined   key_floats
    !!----------------------------------------------------------------------
    !!   'key_floats'                                        drifting floats
@@ -61,6 +61,6 @@
       !!----------------------------------------------------------------------
       ALLOCATE( wb(jpi,jpj,jpk) , nfloat(jpnfl) , nisobfl(jpnfl) , ngrpfl(jpnfl) , &
-                flxx(jpnfl)     , flyy(jpnfl)   , flzz(jpnfl)    ,                 & 
-                tpifl(jpnfl)    , tpjfl(jpnfl)  , tpkfl(jpnfl)   , STAT=flo_oce_alloc )
+         &      flxx(jpnfl)     , flyy(jpnfl)   , flzz(jpnfl)    ,                 & 
+         &      tpifl(jpnfl)    , tpjfl(jpnfl)  , tpkfl(jpnfl)   , STAT=flo_oce_alloc )
       !
       IF( lk_mpp             )   CALL mpp_sum ( flo_oce_alloc )
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/FLO/floats.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/FLO/floats.F90	(revision 9123)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/FLO/floats.F90	(revision 9124)
@@ -7,5 +7,5 @@
    !!   NEMO     1.0  ! 2002-06  (A. Bozec)  F90, Free form and module
    !!----------------------------------------------------------------------
-#if   defined key_floats
+#if   defined   key_floats
    !!----------------------------------------------------------------------
    !!   'key_floats'                                     float trajectories
@@ -22,4 +22,5 @@
    USE flo4rk          ! Trajectories, Runge Kutta scheme (flo_4rk routine)
    USE floblk          ! Trajectories, Blanke scheme      (flo_blk routine)
+   !
    USE in_out_manager  ! I/O manager
    USE timing          ! preformance summary
@@ -52,5 +53,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('flo_stp')
+      IF( ln_timing )   CALL timing_start('flo_stp')
       !
       IF( ln_flork4 ) THEN   ;   CALL flo_4rk( kt )        ! Trajectories using a 4th order Runge Kutta scheme
@@ -66,5 +67,5 @@
       wb(:,:,:) = wn(:,:,:)         ! Save the old vertical velocity field
       !
-      IF( nn_timing == 1 )   CALL timing_stop('flo_stp')
+      IF( ln_timing )   CALL timing_stop('flo_stp')
       !
    END SUBROUTINE flo_stp
@@ -77,11 +78,9 @@
       !! ** Purpose :   Read the namelist of floats
       !!----------------------------------------------------------------------
-      INTEGER :: jfl
-      INTEGER :: ios                 ! Local integer output status for namelist read
+      INTEGER ::   jfl
+      INTEGER ::   ios                 ! Local integer output status for namelist read
       !
       NAMELIST/namflo/ jpnfl, jpnnewflo, ln_rstflo, nn_writefl, nn_stockfl, ln_argo, ln_flork4, ln_ariane, ln_flo_ascii
       !!---------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )   CALL timing_start('flo_init')
       !
       IF(lwp) WRITE(numout,*)
@@ -125,16 +124,13 @@
       IF( flo_rst_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'flo_rst : unable to allocate arrays' )
       !
-      !memory allocation 
-      jpnrstflo = jpnfl-jpnnewflo
-
-      !vertical axe for netcdf IOM ouput
-      DO jfl=1,jpnfl ; nfloat(jfl)=jfl ; ENDDO
-
+      jpnrstflo = jpnfl-jpnnewflo   ! memory allocation 
+      !
+      DO jfl = 1, jpnfl             ! vertical axe for netcdf IOM ouput
+         nfloat(jfl) = jfl 
+      END DO
       !
       CALL flo_dom                  ! compute/read initial position of floats
-
+      !
       wb(:,:,:) = wn(:,:,:)         ! set wb for computation of floats trajectories at the first time step
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('flo_init')
       !
    END SUBROUTINE flo_init
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbstp.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbstp.F90	(revision 9123)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbstp.F90	(revision 9124)
@@ -1,4 +1,3 @@
 MODULE icbstp
-
    !!======================================================================
    !!                       ***  MODULE  icbstp  ***
@@ -13,4 +12,5 @@
    !!            -    !                            into icb copies with haloes
    !!----------------------------------------------------------------------
+
    !!----------------------------------------------------------------------
    !!   icb_stp       : start iceberg tracking
@@ -20,21 +20,22 @@
    USE dom_oce        ! ocean domain
    USE sbc_oce        ! ocean surface forcing
-   USE phycst
+   USE phycst         ! physical constants
+   !
+   USE icb_oce        ! iceberg: define arrays
+   USE icbini         ! iceberg: initialisation routines
+   USE icbutl         ! iceberg: utility routines
+   USE icbrst         ! iceberg: restart routines
+   USE icbdyn         ! iceberg: dynamics (ie advection) routines
+   USE icbclv         ! iceberg: calving routines
+   USE icbthm         ! iceberg: thermodynamics routines
+   USE icblbc         ! iceberg: lateral boundary routines (including mpp)
+   USE icbtrj         ! iceberg: trajectory I/O routines
+   USE icbdia         ! iceberg: budget
+   !
    USE in_out_manager ! nemo IO
-   USE lib_mpp
-   USE iom
-   USE fldread
+   USE lib_mpp        ! massively parallel library 
+   USE iom            ! I/O manager
+   USE fldread        ! field read
    USE timing         ! timing
-
-   USE icb_oce        ! define iceberg arrays
-   USE icbini         ! iceberg initialisation routines
-   USE icbutl         ! iceberg utility routines
-   USE icbrst         ! iceberg restart routines
-   USE icbdyn         ! iceberg dynamics (ie advection) routines
-   USE icbclv         ! iceberg calving routines
-   USE icbthm         ! iceberg thermodynamics routines
-   USE icblbc         ! iceberg lateral boundary routines (including mpp)
-   USE icbtrj         ! iceberg trajectory I/O routines
-   USE icbdia         ! iceberg budget
 
    IMPLICIT NONE
@@ -64,86 +65,83 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 ) CALL timing_start('icb_stp')
+      IF( ln_timing )   CALL timing_start('icb_stp')
 
-      !! start of timestep housekeeping
-
+      !                       !==  start of timestep housekeeping  ==!
+      !
       nktberg = kt
-
-      IF( nn_test_icebergs < 0 ) THEN      ! read calving data
+      !
+      IF( nn_test_icebergs < 0 ) THEN     !* read calving data
          !
          CALL fld_read ( kt, 1, sf_icb )
-         src_calving(:,:)      = sf_icb(1)%fnow(:,:,1)    ! calving in km^3/year (water equivalent)
+         src_calving     (:,:) = sf_icb(1)%fnow(:,:,1)    ! calving in km^3/year (water equivalent)
          src_calving_hflx(:,:) = 0._wp                    ! NO heat flux for now
          !
       ENDIF
-
+      !
       berg_grid%floating_melt(:,:) = 0._wp
-
-      ! anything that needs to be reset to zero each timestep for budgets is dealt with here
-      CALL icb_dia_step()
-
+      !
+      !                                   !* anything that needs to be reset to zero each timestep 
+      CALL icb_dia_step()                 !  for budgets is dealt with here
+      !
+      !                                   !* write out time
       ll_verbose = .FALSE.
-      IF( nn_verbose_write > 0 .AND. &
-          MOD(kt-1,nn_verbose_write ) == 0 )   ll_verbose = nn_verbose_level >= 0
-
-      ! write out time
-      IF( ll_verbose ) WRITE(numicb,9100) nktberg, ndastp, nsec_day
+      IF( nn_verbose_write > 0 .AND. MOD( kt-1 , nn_verbose_write ) == 0 )   ll_verbose = ( nn_verbose_level >= 0 )
+      !
+      IF( ll_verbose )   WRITE(numicb,9100) nktberg, ndastp, nsec_day
  9100 FORMAT('kt= ',i8, ' day= ',i8,' secs=',i8)
-
-      ! copy nemo forcing arrays into iceberg versions with extra halo
-      ! only necessary for variables not on T points
-      CALL icb_utl_copy()
-
-      !!----------------------------------------------------------------------
-      !! process icebergs
-
+      !
+      !                                   !* copy nemo forcing arrays into iceberg versions with extra halo
+      CALL icb_utl_copy()                 ! only necessary for variables not on T points
+      !
+      !
+      !                       !==  process icebergs  ==!
+      !                              !
                                      CALL icb_clv_flx( kt )   ! Accumulate ice from calving
-
+      !                              !
                                      CALL icb_clv()           ! Calve excess stored ice into icebergs
-
-
-!                               !==  For each berg, evolve  ==!
+      !                              !
+      !
+      !                       !==  For each berg, evolve  ==!
       !
       IF( ASSOCIATED(first_berg) )   CALL icb_dyn( kt )       ! ice berg dynamics
 
-      IF( lk_mpp ) THEN          ;   CALL icb_lbc_mpp()       ! Send bergs to other PEs
-      ELSE                       ;   CALL icb_lbc()           ! Deal with any cyclic boundaries in non-mpp case
+      IF( lk_mpp ) THEN   ;          CALL icb_lbc_mpp()       ! Send bergs to other PEs
+      ELSE                ;          CALL icb_lbc()           ! Deal with any cyclic boundaries in non-mpp case
       ENDIF
 
       IF( ASSOCIATED(first_berg) )   CALL icb_thm( kt )       ! Ice berg thermodynamics (melting) + rolling
-
-      !!----------------------------------------------------------------------
-      !! end of timestep housekeeping
-
+      !
+      !
+      !                       !==  diagnostics and output  ==!
+      !
+      !                                   !* For each berg, record trajectory (when needed)
       ll_sample_traj = .FALSE.
       IF( nn_sample_rate > 0 .AND. MOD(kt-1,nn_sample_rate) == 0 )   ll_sample_traj = .TRUE.
-      IF( ll_sample_traj .AND.   &
-          ASSOCIATED(first_berg) )   CALL icb_trj_write( kt )  ! For each berg, record trajectory
+      IF( ll_sample_traj .AND. ASSOCIATED(first_berg) )   CALL icb_trj_write( kt )
 
-      ! Gridded diagnostics
-      ! To get these iom_put's and those preceding to actually do something
-      ! use key_iomput in cpp file and create content for XML file
-
+      !                                   !* Gridded diagnostics
+      !                                   !  To get these iom_put's and those preceding to actually do something
+      !                                   !  use key_iomput in cpp file and create content for XML file
+      !
       CALL iom_put( "calving"           , berg_grid%calving      (:,:)   )  ! 'calving mass input'
       CALL iom_put( "berg_floating_melt", berg_grid%floating_melt(:,:)   )  ! 'Melt rate of icebergs + bits' , 'kg/m2/s'
       CALL iom_put( "berg_stored_ice"   , berg_grid%stored_ice   (:,:,:) )  ! 'Accumulated ice mass by class', 'kg'
-
-      ! store mean budgets
-      CALL icb_dia_put()
-
-      ! Dump icebergs to screen
-      if ( nn_verbose_level >= 2 )   CALL icb_utl_print( 'icb_stp, status', kt )
-
-      ! Diagnose budgets
+      !
+      CALL icb_dia_put()                  !* store mean budgets
+      !
+      !                                   !*  Dump icebergs to screen
+      IF( nn_verbose_level >= 2 )   CALL icb_utl_print( 'icb_stp, status', kt )
+      !
+      !                                   !* Diagnose budgets
       ll_budget = .FALSE.
       IF( nn_verbose_write > 0 .AND. MOD(kt-1,nn_verbose_write) == 0 )   ll_budget = ln_bergdia
       CALL icb_dia( ll_budget )
-
-      IF( MOD(kt,nn_stock) == 0 ) THEN
+      !
+      IF( MOD(kt,nn_stock) == 0 ) THEN    !* restart
          CALL icb_rst_write( kt )
          IF( nn_sample_rate > 0 )   CALL icb_trj_sync()
       ENDIF
-
-      IF( nn_timing == 1 ) CALL timing_stop('icb_stp')
+      !
+      IF( ln_timing )   CALL timing_stop('icb_stp')
       !
    END SUBROUTINE icb_stp
@@ -157,14 +155,15 @@
       !!
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in )  :: kt
+      INTEGER, INTENT( in )  ::   kt   ! model time-step index
       !!----------------------------------------------------------------------
-
+      !
       ! only write a restart if not done in icb_stp
-      IF( MOD(kt,nn_stock) .NE. 0 ) CALL icb_rst_write( kt )
+      IF( MOD(kt,nn_stock) /= 0 )   CALL icb_rst_write( kt )
 
       ! finish with trajectories if they were written
-      IF( nn_sample_rate .GT. 0 ) CALL icb_trj_end()
+      IF( nn_sample_rate > 0 )   CALL icb_trj_end()
 
-      IF(lwp)   WRITE(numout,'(a,i6)') 'icebergs: icb_end complete', narea
+      IF(lwp) WRITE(numout,'(a,i6)') 'icebergs: icb_end complete', narea
+      !
       CALL flush( numicb )
       CLOSE( numicb )
@@ -173,4 +172,3 @@
 
    !!-------------------------------------------------------------------------
-
 END MODULE icbstp
Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 9123)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/IOM/in_out_manager.F90	(revision 9124)
@@ -100,7 +100,4 @@
    LOGICAL ::   ln_ctl           !: run control for debugging
    LOGICAL ::   ln_timing        !: run control for timing
-!!gm to be removed at the end of the 2017 merge party
-   INTEGER ::   nn_timing        !: run control for timing
-!!gm end
    LOGICAL ::   ln_diacfl        !: flag whether to create CFL diagnostics
    INTEGER ::   nn_print         !: level of print (0 no print)
